/* gpx-graph.c generated by valac, the Vala compiler
 * generated from gpx-graph.vala, do not modify */

/* Gpx Viewer
 * Copyright (C) 2009-2009 Qball Cow <qball@sarine.nl>
 * Project homepage: http://blog.sarine.nl/

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <gtk/gtk.h>
#include <pango/pango.h>
#include <cairo.h>
#include <time.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <pango/pangocairo.h>
#include <stdio.h>


#define GPX_TYPE_GRAPH (gpx_graph_get_type ())
#define GPX_GRAPH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPX_TYPE_GRAPH, GpxGraph))
#define GPX_GRAPH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPX_TYPE_GRAPH, GpxGraphClass))
#define GPX_IS_GRAPH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPX_TYPE_GRAPH))
#define GPX_IS_GRAPH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPX_TYPE_GRAPH))
#define GPX_GRAPH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPX_TYPE_GRAPH, GpxGraphClass))

typedef struct _GpxGraph GpxGraph;
typedef struct _GpxGraphClass GpxGraphClass;
typedef struct _GpxGraphPrivate GpxGraphPrivate;

#define GPX_TYPE_TRACK (gpx_track_get_type ())
#define GPX_TRACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPX_TYPE_TRACK, GpxTrack))
#define GPX_TRACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPX_TYPE_TRACK, GpxTrackClass))
#define GPX_IS_TRACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPX_TYPE_TRACK))
#define GPX_IS_TRACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPX_TYPE_TRACK))
#define GPX_TRACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPX_TYPE_TRACK, GpxTrackClass))

typedef struct _GpxTrack GpxTrack;
typedef struct _GpxTrackClass GpxTrackClass;

#define GPX_GRAPH_TYPE_GRAPH_MODE (gpx_graph_graph_mode_get_type ())

#define GPX_TYPE_POINT (gpx_point_get_type ())
#define GPX_POINT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPX_TYPE_POINT, GpxPoint))
#define GPX_POINT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPX_TYPE_POINT, GpxPointClass))
#define GPX_IS_POINT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPX_TYPE_POINT))
#define GPX_IS_POINT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPX_TYPE_POINT))
#define GPX_POINT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPX_TYPE_POINT, GpxPointClass))

typedef struct _GpxPoint GpxPoint;
typedef struct _GpxPointClass GpxPointClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _pango_font_description_free0(var) ((var == NULL) ? NULL : (var = (pango_font_description_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _gpx_point_unref0(var) ((var == NULL) ? NULL : (var = (gpx_point_unref (var), NULL)))
typedef struct _GpxTrackPrivate GpxTrackPrivate;
typedef struct _GpxPointPrivate GpxPointPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

struct _GpxGraph {
	GtkEventBox parent_instance;
	GpxGraphPrivate * priv;
	GpxTrack* track;
};

struct _GpxGraphClass {
	GtkEventBoxClass parent_class;
};

typedef enum  {
	GPX_GRAPH_GRAPH_MODE_SPEED,
	GPX_GRAPH_GRAPH_MODE_ELEVATION,
	GPX_GRAPH_GRAPH_MODE_DISTANCE,
	GPX_GRAPH_GRAPH_MODE_ACCELERATION_H,
	GPX_GRAPH_GRAPH_MODE_SPEED_V,
	GPX_GRAPH_GRAPH_MODE_NUM_GRAPH_MODES
} GpxGraphGraphMode;

struct _GpxGraphPrivate {
	GpxGraphGraphMode _mode;
	gint _smooth_factor;
	gboolean _show_points;
	PangoFontDescription* fd;
	cairo_surface_t* surf;
	gint LEFT_OFFSET;
	gint BOTTOM_OFFSET;
	time_t highlight;
	GpxPoint* draw_current;
	GpxPoint* start;
	GpxPoint* stop;
};

struct _GpxTrack {
	GObject parent_instance;
	GpxTrackPrivate * priv;
	double total_distance;
	double max_speed;
	GList* points;
	GpxPoint* top;
	GpxPoint* bottom;
	double max_elevation;
	double min_elevation;
};

struct _GpxTrackClass {
	GObjectClass parent_class;
};

struct _GpxPoint {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GpxPointPrivate * priv;
	double lat;
	double lon;
	double lat_dec;
	double lon_dec;
	double distance;
	double elevation;
	char* time;
	double speed;
};

struct _GpxPointClass {
	GTypeClass parent_class;
	void (*finalize) (GpxPoint *self);
};


static char** gpx_graph_GraphModeName;
static gint gpx_graph_GraphModeName_length1;
static char** gpx_graph_GraphModeName = NULL;
static gint gpx_graph_GraphModeName_length1 = 0;
static gint _gpx_graph_GraphModeName_size_ = 0;
static gpointer gpx_graph_parent_class = NULL;

#define LOG_DOMAIN "GPX_GRAPH"
#define unique_graph VERSION
GType gpx_graph_get_type (void) G_GNUC_CONST;
GType gpx_track_get_type (void) G_GNUC_CONST;
GType gpx_graph_graph_mode_get_type (void) G_GNUC_CONST;
gpointer gpx_point_ref (gpointer instance);
void gpx_point_unref (gpointer instance);
GParamSpec* gpx_param_spec_point (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void gpx_value_set_point (GValue* value, gpointer v_object);
void gpx_value_take_point (GValue* value, gpointer v_object);
gpointer gpx_value_get_point (const GValue* value);
GType gpx_point_get_type (void) G_GNUC_CONST;
#define GPX_GRAPH_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GPX_TYPE_GRAPH, GpxGraphPrivate))
enum  {
	GPX_GRAPH_DUMMY_PROPERTY,
	GPX_GRAPH_SMOOTH_FACTOR,
	GPX_GRAPH_SHOW_POINTS,
	GPX_GRAPH_MODE
};
void gpx_graph_hide_info (GpxGraph* self);
void gpx_graph_show_info (GpxGraph* self, GpxPoint* cur_point);
void gpx_graph_set_highlight (GpxGraph* self, time_t highlight);
static void gpx_graph_size_allocate_cb (GpxGraph* self, GdkRectangle* alloc);
static void _gpx_graph_size_allocate_cb_gtk_widget_size_allocate (GtkWidget* _sender, GdkRectangle* allocation, gpointer self);
static gboolean gpx_graph_button_press_event_cb (GpxGraph* self, GdkEventButton* event);
static gboolean _gpx_graph_button_press_event_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean gpx_graph_motion_notify_event_cb (GpxGraph* self, GdkEventMotion* event);
static gboolean _gpx_graph_motion_notify_event_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self);
static gboolean gpx_graph_button_release_event_cb (GpxGraph* self, GdkEventButton* event);
static gboolean _gpx_graph_button_release_event_cb_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
GpxGraph* gpx_graph_new (void);
GpxGraph* gpx_graph_construct (GType object_type);
void gpx_graph_set_track (GpxGraph* self, GpxTrack* track);
time_t gpx_track_get_total_time (GpxTrack* self);
time_t gpx_point_get_time (GpxPoint* self);
static GpxPoint* gpx_graph_get_point_from_position (GpxGraph* self, double x, double y);
static void gpx_graph_update_surface (GpxGraph* self, GtkWidget* win);
static gboolean gpx_graph_real_expose_event (GtkWidget* base, GdkEventExpose* event);
double gpx_track_get_track_average (GpxTrack* self);
gboolean gpx_graph_get_show_points (GpxGraph* self);
double gpx_track_calculate_point_to_point_speed (GpxTrack* self, GpxPoint* a, GpxPoint* b);
double gpx_track_calculate_moving_average (GpxTrack* self, GpxPoint* start, GpxPoint* stop, time_t* moving_time);
gint gpx_graph_get_smooth_factor (GpxGraph* self);
void gpx_graph_set_smooth_factor (GpxGraph* self, gint value);
void gpx_graph_set_show_points (GpxGraph* self, gboolean value);
GpxGraphGraphMode gpx_graph_get_mode (GpxGraph* self);
void gpx_graph_set_mode (GpxGraph* self, GpxGraphGraphMode value);
static void gpx_graph_finalize (GObject* obj);
static void gpx_graph_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void gpx_graph_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void g_cclosure_user_marshal_VOID__GPX_POINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_GPX_POINT_GPX_POINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);

GType gpx_graph_graph_mode_get_type (void) {
	static volatile gsize gpx_graph_graph_mode_type_id__volatile = 0;
	if (g_once_init_enter (&gpx_graph_graph_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{GPX_GRAPH_GRAPH_MODE_SPEED, "GPX_GRAPH_GRAPH_MODE_SPEED", "speed"}, {GPX_GRAPH_GRAPH_MODE_ELEVATION, "GPX_GRAPH_GRAPH_MODE_ELEVATION", "elevation"}, {GPX_GRAPH_GRAPH_MODE_DISTANCE, "GPX_GRAPH_GRAPH_MODE_DISTANCE", "distance"}, {GPX_GRAPH_GRAPH_MODE_ACCELERATION_H, "GPX_GRAPH_GRAPH_MODE_ACCELERATION_H", "acceleration-h"}, {GPX_GRAPH_GRAPH_MODE_SPEED_V, "GPX_GRAPH_GRAPH_MODE_SPEED_V", "speed-v"}, {GPX_GRAPH_GRAPH_MODE_NUM_GRAPH_MODES, "GPX_GRAPH_GRAPH_MODE_NUM_GRAPH_MODES", "num-graph-modes"}, {0, NULL, NULL}};
		GType gpx_graph_graph_mode_type_id;
		gpx_graph_graph_mode_type_id = g_enum_register_static ("GpxGraphGraphMode", values);
		g_once_init_leave (&gpx_graph_graph_mode_type_id__volatile, gpx_graph_graph_mode_type_id);
	}
	return gpx_graph_graph_mode_type_id__volatile;
}


void gpx_graph_hide_info (GpxGraph* self) {
	g_return_if_fail (self != NULL);
	self->priv->draw_current = NULL;
	gtk_widget_queue_draw ((GtkWidget*) self);
}


void gpx_graph_show_info (GpxGraph* self, GpxPoint* cur_point) {
	g_return_if_fail (self != NULL);
	self->priv->draw_current = cur_point;
	gtk_widget_queue_draw ((GtkWidget*) self);
}


void gpx_graph_set_highlight (GpxGraph* self, time_t highlight) {
	g_return_if_fail (self != NULL);
	self->priv->highlight = highlight;
	gtk_widget_queue_draw ((GtkWidget*) self);
}


static void _gpx_graph_size_allocate_cb_gtk_widget_size_allocate (GtkWidget* _sender, GdkRectangle* allocation, gpointer self) {
	gpx_graph_size_allocate_cb (self, allocation);
}


static gboolean _gpx_graph_button_press_event_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = gpx_graph_button_press_event_cb (self, event);
	return result;
}


static gboolean _gpx_graph_motion_notify_event_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self) {
	gboolean result;
	result = gpx_graph_motion_notify_event_cb (self, event);
	return result;
}


static gboolean _gpx_graph_button_release_event_cb_gtk_widget_button_release_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = gpx_graph_button_release_event_cb (self, event);
	return result;
}


GpxGraph* gpx_graph_construct (GType object_type) {
	GpxGraph * self;
	PangoFontDescription* _tmp0_;
	self = g_object_newv (object_type, 0, NULL);
	self->priv->fd = (_tmp0_ = pango_font_description_new (), _pango_font_description_free0 (self->priv->fd), _tmp0_);
	pango_font_description_set_family (self->priv->fd, "sans mono");
	gtk_widget_set_app_paintable ((GtkWidget*) self, TRUE);
	gtk_event_box_set_visible_window ((GtkEventBox*) self, TRUE);
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) _gpx_graph_size_allocate_cb_gtk_widget_size_allocate, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) _gpx_graph_button_press_event_cb_gtk_widget_button_press_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "motion-notify-event", (GCallback) _gpx_graph_motion_notify_event_cb_gtk_widget_motion_notify_event, self, 0);
	g_signal_connect_object ((GtkWidget*) self, "button-release-event", (GCallback) _gpx_graph_button_release_event_cb_gtk_widget_button_release_event, self, 0);
	return self;
}


GpxGraph* gpx_graph_new (void) {
	return gpx_graph_construct (GPX_TYPE_GRAPH);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void gpx_graph_set_track (GpxGraph* self, GpxTrack* track) {
	GpxTrack* _tmp0_;
	cairo_surface_t* _tmp1_;
	GpxPoint* _tmp2_;
	GpxPoint* _tmp3_;
	gboolean _tmp4_ = FALSE;
	g_return_if_fail (self != NULL);
	self->priv->highlight = (time_t) 0;
	self->track = (_tmp0_ = _g_object_ref0 (track), _g_object_unref0 (self->track), _tmp0_);
	self->priv->surf = (_tmp1_ = NULL, _cairo_surface_destroy0 (self->priv->surf), _tmp1_);
	gtk_widget_queue_draw ((GtkWidget*) self);
	self->priv->start = (_tmp2_ = NULL, _gpx_point_unref0 (self->priv->start), _tmp2_);
	self->priv->stop = (_tmp3_ = NULL, _gpx_point_unref0 (self->priv->stop), _tmp3_);
	if (self->track != NULL) {
		_tmp4_ = self->track->points != NULL;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		g_signal_emit_by_name (self, "selection-changed", self->track, (GpxPoint*) g_list_first (self->track->points)->data, (GpxPoint*) g_list_last (self->track->points)->data);
	} else {
		g_signal_emit_by_name (self, "selection-changed", self->track, NULL, NULL);
	}
}


static gpointer _gpx_point_ref0 (gpointer self) {
	return self ? gpx_point_ref (self) : NULL;
}


static GpxPoint* gpx_graph_get_point_from_position (GpxGraph* self, double x, double y) {
	GpxPoint* result = NULL;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, NULL);
	if (self->track == NULL) {
		result = NULL;
		return result;
	}
	if (x > self->priv->LEFT_OFFSET) {
		_tmp0_ = x < (((GtkWidget*) self)->allocation.width - 10);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		double elapsed_time;
		time_t time;
		GList* iter;
		elapsed_time = (double) gpx_track_get_total_time (self->track);
		time = (time_t) (((x - self->priv->LEFT_OFFSET) / ((((GtkWidget*) self)->allocation.width - 10) - self->priv->LEFT_OFFSET)) * elapsed_time);
		iter = g_list_first (self->track->points);
		time = time + gpx_point_get_time ((GpxPoint*) iter->data);
		while (TRUE) {
			gboolean _tmp1_ = FALSE;
			if (!(iter->next != NULL)) {
				break;
			}
			if (time < gpx_point_get_time ((GpxPoint*) iter->next->data)) {
				gboolean _tmp2_ = FALSE;
				if (time == gpx_point_get_time ((GpxPoint*) iter->data)) {
					_tmp2_ = TRUE;
				} else {
					_tmp2_ = time > gpx_point_get_time ((GpxPoint*) iter->data);
				}
				_tmp1_ = _tmp2_;
			} else {
				_tmp1_ = FALSE;
			}
			if (_tmp1_) {
				result = _gpx_point_ref0 ((GpxPoint*) iter->data);
				return result;
			}
			iter = iter->next;
		}
	}
	result = NULL;
	return result;
}


static gboolean gpx_graph_button_press_event_cb (GpxGraph* self, GdkEventButton* event) {
	gboolean result = FALSE;
	GpxPoint* point;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->track == NULL) {
		result = FALSE;
		return result;
	}
	point = gpx_graph_get_point_from_position (self, (*event).x, (*event).y);
	if (point != NULL) {
		if ((*event).button == 1) {
			GpxPoint* _tmp0_;
			self->priv->start = (_tmp0_ = _gpx_point_ref0 (point), _gpx_point_unref0 (self->priv->start), _tmp0_);
		} else {
			GpxPoint* _tmp1_;
			self->priv->start = (_tmp1_ = NULL, _gpx_point_unref0 (self->priv->start), _tmp1_);
			g_signal_emit_by_name (self, "point-clicked", point);
		}
	}
	result = FALSE;
	return result;
}


static gboolean gpx_graph_motion_notify_event_cb (GpxGraph* self, GdkEventMotion* event) {
	gboolean result = FALSE;
	GpxPoint* point;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->track == NULL) {
		result = FALSE;
		return result;
	}
	if (self->priv->start == NULL) {
		result = FALSE;
		return result;
	}
	point = gpx_graph_get_point_from_position (self, (*event).x, (*event).y);
	if (point != NULL) {
		GpxPoint* _tmp0_;
		gboolean _tmp1_ = FALSE;
		self->priv->stop = (_tmp0_ = _gpx_point_ref0 (point), _gpx_point_unref0 (self->priv->stop), _tmp0_);
		gtk_widget_queue_draw ((GtkWidget*) self);
		if (self->priv->start != NULL) {
			_tmp1_ = self->priv->stop != NULL;
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			if (gpx_point_get_time (self->priv->start) != gpx_point_get_time (self->priv->stop)) {
				if (gpx_point_get_time (self->priv->start) < gpx_point_get_time (self->priv->stop)) {
					g_signal_emit_by_name (self, "selection-changed", self->track, self->priv->start, self->priv->stop);
				} else {
					g_signal_emit_by_name (self, "selection-changed", self->track, self->priv->stop, self->priv->start);
				}
				result = FALSE;
				return result;
			}
		}
		g_signal_emit_by_name (self, "selection-changed", self->track, (GpxPoint*) g_list_first (self->track->points)->data, (GpxPoint*) g_list_last (self->track->points)->data);
	}
	result = FALSE;
	return result;
}


static gboolean gpx_graph_button_release_event_cb (GpxGraph* self, GdkEventButton* event) {
	gboolean result = FALSE;
	GpxPoint* point;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->track == NULL) {
		result = FALSE;
		return result;
	}
	point = gpx_graph_get_point_from_position (self, (*event).x, (*event).y);
	if (point != NULL) {
		if ((*event).button == 1) {
			GpxPoint* _tmp0_;
			self->priv->stop = (_tmp0_ = _gpx_point_ref0 (point), _gpx_point_unref0 (self->priv->stop), _tmp0_);
		} else {
			GpxPoint* _tmp1_;
			self->priv->stop = (_tmp1_ = NULL, _gpx_point_unref0 (self->priv->stop), _tmp1_);
		}
		gtk_widget_queue_draw ((GtkWidget*) self);
		if ((*event).button == 1) {
			gboolean _tmp2_ = FALSE;
			if (self->priv->start != NULL) {
				_tmp2_ = self->priv->stop != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			if (_tmp2_) {
				if (gpx_point_get_time (self->priv->start) != gpx_point_get_time (self->priv->stop)) {
					if (gpx_point_get_time (self->priv->start) < gpx_point_get_time (self->priv->stop)) {
						g_signal_emit_by_name (self, "selection-changed", self->track, self->priv->start, self->priv->stop);
					} else {
						g_signal_emit_by_name (self, "selection-changed", self->track, self->priv->stop, self->priv->start);
					}
					result = FALSE;
					return result;
				}
			}
			g_signal_emit_by_name (self, "selection-changed", self->track, (GpxPoint*) g_list_first (self->track->points)->data, (GpxPoint*) g_list_last (self->track->points)->data);
		}
	}
	result = FALSE;
	return result;
}


static void gpx_graph_size_allocate_cb (GpxGraph* self, GdkRectangle* alloc) {
	cairo_surface_t* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->surf = (_tmp0_ = NULL, _cairo_surface_destroy0 (self->priv->surf), _tmp0_);
}


static gboolean gpx_graph_real_expose_event (GtkWidget* base, GdkEventExpose* event) {
	GpxGraph * self;
	gboolean result = FALSE;
	cairo_t* ctx;
	gboolean _tmp0_ = FALSE;
	self = (GpxGraph*) base;
	ctx = gdk_cairo_create ((GdkDrawable*) ((GtkWidget*) self)->window);
	if (self->priv->surf == NULL) {
		gpx_graph_update_surface (self, (GtkWidget*) self);
	}
	cairo_set_source_surface (ctx, self->priv->surf, (double) 0, (double) 0);
	gdk_cairo_region (ctx, (*event).region);
	cairo_clip (ctx);
	cairo_paint (ctx);
	cairo_translate (ctx, (double) self->priv->LEFT_OFFSET, (double) 20);
	if (self->priv->start != NULL) {
		_tmp0_ = self->priv->stop != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		if (gpx_point_get_time (self->priv->start) != gpx_point_get_time (self->priv->stop)) {
			GpxPoint* f;
			double elapsed_time;
			double graph_width;
			double graph_height;
			f = _gpx_point_ref0 ((GpxPoint*) g_list_first (self->track->points)->data);
			elapsed_time = (double) gpx_track_get_total_time (self->track);
			graph_width = (double) ((((GtkWidget*) self)->allocation.width - self->priv->LEFT_OFFSET) - 10);
			graph_height = (double) ((((GtkWidget*) self)->allocation.height - 20) - self->priv->BOTTOM_OFFSET);
			cairo_set_source_rgba (ctx, 0.3, 0.2, 0.3, 0.8);
			cairo_rectangle (ctx, ((gpx_point_get_time (self->priv->start) - gpx_point_get_time (f)) / elapsed_time) * graph_width, (double) 0, ((gpx_point_get_time (self->priv->stop) - gpx_point_get_time (self->priv->start)) / elapsed_time) * graph_width, graph_height);
			cairo_stroke_preserve (ctx);
			cairo_fill (ctx);
			_gpx_point_unref0 (f);
		}
	}
	if (self->priv->highlight > 0) {
		GpxPoint* f;
		double elapsed_time;
		double graph_width;
		double graph_height;
		double hl;
		f = _gpx_point_ref0 ((GpxPoint*) g_list_first (self->track->points)->data);
		elapsed_time = (double) gpx_track_get_total_time (self->track);
		graph_width = (double) ((((GtkWidget*) self)->allocation.width - self->priv->LEFT_OFFSET) - 10);
		graph_height = (double) ((((GtkWidget*) self)->allocation.height - 20) - self->priv->BOTTOM_OFFSET);
		hl = ((self->priv->highlight - gpx_point_get_time (f)) / elapsed_time) * graph_width;
		cairo_set_source_rgba (ctx, 0.8, 0.2, 0.3, 0.8);
		cairo_move_to (ctx, hl, (double) 0);
		cairo_line_to (ctx, hl, graph_height);
		cairo_stroke_preserve (ctx);
		cairo_fill (ctx);
		if (self->priv->draw_current != NULL) {
			PangoLayout* layout;
			gint w = 0;
			gint h = 0;
			char* text;
			double x_pos;
			layout = pango_cairo_create_layout (ctx);
			text = g_strdup ("");
			x_pos = 0.0;
			if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_SPEED) {
				char* _tmp1_;
				text = (_tmp1_ = g_strdup_printf ("%.1f km/h", self->priv->draw_current->speed), _g_free0 (text), _tmp1_);
			} else {
				if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_ELEVATION) {
					char* _tmp2_;
					text = (_tmp2_ = g_strdup_printf ("%.1f m", self->priv->draw_current->elevation), _g_free0 (text), _tmp2_);
				} else {
					if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_DISTANCE) {
						char* _tmp3_;
						text = (_tmp3_ = g_strdup_printf ("%.1f km", self->priv->draw_current->distance), _g_free0 (text), _tmp3_);
					} else {
						result = FALSE;
						_g_free0 (text);
						_g_object_unref0 (layout);
						_gpx_point_unref0 (f);
						_cairo_destroy0 (ctx);
						return result;
					}
				}
			}
			pango_font_description_set_absolute_size (self->priv->fd, (double) (12 * 1024));
			pango_layout_set_font_description (layout, self->priv->fd);
			pango_layout_set_text (layout, text, -1);
			pango_layout_get_pixel_size (layout, &w, &h);
			x_pos = hl - ((w + 8) / 2.0);
			if (x_pos < (-self->priv->LEFT_OFFSET)) {
				x_pos = 0.0;
			} else {
				if ((hl + ((w + 8) / 2.0)) >= graph_width) {
					x_pos = ((double) graph_width) - ((double) (w + 8.0));
				}
			}
			cairo_rectangle (ctx, x_pos, (double) ((-h) - 2), (double) (w + 8), (double) (h + 4));
			cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, 1.0);
			cairo_stroke_preserve (ctx);
			cairo_set_source_rgba (ctx, 0.8, 0.8, 0.8, 0.8);
			cairo_fill (ctx);
			cairo_move_to (ctx, x_pos + 4, (double) (-h));
			pango_cairo_layout_path (ctx, layout);
			cairo_set_source_rgba (ctx, 1.0, 1.0, 1.0, 1.0);
			cairo_stroke_preserve (ctx);
			cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, 1.0);
			cairo_fill (ctx);
			_g_free0 (text);
			_g_object_unref0 (layout);
		}
		_gpx_point_unref0 (f);
	}
	result = FALSE;
	_cairo_destroy0 (ctx);
	return result;
}


static void gpx_graph_update_surface (GpxGraph* self, GtkWidget* win) {
	cairo_t* ctx;
	cairo_surface_t* _tmp0_;
	cairo_t* _tmp1_;
	double max_value;
	double min_value;
	double range;
	double elapsed_time;
	GpxPoint* f;
	double graph_width;
	double graph_height;
	PangoLayout* layout;
	double j;
	double step_size;
	gint wt = 0;
	gint ht = 0;
	GList* iter;
	gboolean _tmp15_ = FALSE;
	double start_speed;
	double pref_speed;
	double pref_speed_threshold;
	gboolean _tmp20_ = FALSE;
	guint interval;
	gint current;
	guint i = 0U;
	gint w = 0;
	gint h = 0;
	char* mtext;
	g_return_if_fail (self != NULL);
	g_return_if_fail (win != NULL);
	ctx = gdk_cairo_create ((GdkDrawable*) win->window);
	self->priv->surf = (_tmp0_ = cairo_surface_create_similar (cairo_get_target (ctx), CAIRO_CONTENT_COLOR_ALPHA, win->allocation.width, win->allocation.height), _cairo_surface_destroy0 (self->priv->surf), _tmp0_);
	ctx = (_tmp1_ = cairo_create (self->priv->surf), _cairo_destroy0 (ctx), _tmp1_);
	g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:360: Updating surface");
	if (self->track->points == NULL) {
		_cairo_destroy0 (ctx);
		return;
	}
	cairo_set_source_rgba (ctx, (double) 1, (double) 1, (double) 1, (double) 1);
	cairo_paint (ctx);
	if (self->track == NULL) {
		_cairo_destroy0 (ctx);
		return;
	}
	max_value = (double) 0;
	min_value = (double) 0;
	range = (double) 0;
	if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_SPEED) {
		if (self->priv->_smooth_factor != 1) {
			GList* iter;
			iter = g_list_first (self->track->points);
			while (TRUE) {
				GList* ii;
				double speed;
				gint i;
				gint sf;
				double _tmp4_ = 0.0;
				if (!(iter->next != NULL)) {
					break;
				}
				ii = iter->next;
				speed = (double) 0;
				i = 0;
				sf = self->priv->_smooth_factor;
				{
					gboolean _tmp2_;
					i = 0;
					_tmp2_ = TRUE;
					while (TRUE) {
						gboolean _tmp3_ = FALSE;
						if (!_tmp2_) {
							i++;
						}
						_tmp2_ = FALSE;
						if (i < sf) {
							_tmp3_ = ii->prev != NULL;
						} else {
							_tmp3_ = FALSE;
						}
						if (!_tmp3_) {
							break;
						}
						speed = speed + ((GpxPoint*) ii->data)->speed;
						ii = ii->prev;
					}
				}
				speed = speed / i;
				if (speed > max_value) {
					_tmp4_ = speed;
				} else {
					_tmp4_ = max_value;
				}
				max_value = _tmp4_;
				iter = iter->next;
			}
		} else {
			max_value = self->track->max_speed;
		}
	} else {
		if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_ELEVATION) {
			max_value = self->track->max_elevation;
			min_value = self->track->min_elevation;
		} else {
			if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_DISTANCE) {
				max_value = self->track->total_distance;
				min_value = (double) 0;
			} else {
				if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_ACCELERATION_H) {
					GList* iter;
					iter = g_list_first (self->track->points);
					while (TRUE) {
						GList* ii;
						double speed;
						gint i;
						gint sf;
						double _tmp7_ = 0.0;
						double _tmp8_ = 0.0;
						if (!(iter->next != NULL)) {
							break;
						}
						ii = iter->next;
						speed = (double) 0;
						i = 0;
						sf = self->priv->_smooth_factor;
						{
							gboolean _tmp5_;
							i = 0;
							_tmp5_ = TRUE;
							while (TRUE) {
								gboolean _tmp6_ = FALSE;
								if (!_tmp5_) {
									i++;
								}
								_tmp5_ = FALSE;
								if (i < sf) {
									_tmp6_ = ii->prev != NULL;
								} else {
									_tmp6_ = FALSE;
								}
								if (!_tmp6_) {
									break;
								}
								speed = speed + ((((GpxPoint*) ii->data)->speed - ((GpxPoint*) ii->prev->data)->speed) / (3.6 * (gpx_point_get_time ((GpxPoint*) ii->data) - gpx_point_get_time ((GpxPoint*) ii->prev->data))));
								ii = ii->prev;
							}
						}
						speed = speed / i;
						if (speed > max_value) {
							_tmp7_ = speed;
						} else {
							_tmp7_ = max_value;
						}
						max_value = _tmp7_;
						if (speed < min_value) {
							_tmp8_ = speed;
						} else {
							_tmp8_ = min_value;
						}
						min_value = _tmp8_;
						iter = iter->next;
					}
				} else {
					if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_SPEED_V) {
						GList* iter;
						iter = g_list_first (self->track->points);
						while (TRUE) {
							gboolean _tmp9_ = FALSE;
							GList* ii;
							double speed;
							gint i;
							gint sf;
							double _tmp12_ = 0.0;
							double _tmp13_ = 0.0;
							if (iter != NULL) {
								_tmp9_ = iter->next != NULL;
							} else {
								_tmp9_ = FALSE;
							}
							if (!_tmp9_) {
								break;
							}
							ii = iter->next;
							speed = (double) 0;
							i = 0;
							sf = self->priv->_smooth_factor;
							{
								gboolean _tmp10_;
								i = 0;
								_tmp10_ = TRUE;
								while (TRUE) {
									gboolean _tmp11_ = FALSE;
									if (!_tmp10_) {
										i++;
									}
									_tmp10_ = FALSE;
									if (i < sf) {
										_tmp11_ = ii->prev != NULL;
									} else {
										_tmp11_ = FALSE;
									}
									if (!_tmp11_) {
										break;
									}
									speed = speed + ((((GpxPoint*) ii->data)->elevation - ((GpxPoint*) ii->prev->data)->elevation) / (3.6 * (gpx_point_get_time ((GpxPoint*) ii->data) - gpx_point_get_time ((GpxPoint*) ii->prev->data))));
									ii = ii->prev;
								}
							}
							speed = speed / i;
							if (speed > max_value) {
								_tmp12_ = speed;
							} else {
								_tmp12_ = max_value;
							}
							max_value = _tmp12_;
							if (speed < min_value) {
								_tmp13_ = speed;
							} else {
								_tmp13_ = min_value;
							}
							min_value = _tmp13_;
							iter = iter->next;
						}
					}
				}
			}
		}
	}
	max_value = ceil (max_value);
	range = max_value - min_value;
	elapsed_time = (double) gpx_track_get_total_time (self->track);
	g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:441: Draw Axis");
	g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:443: Max speed: %f, elapsed_time: %f", max_value, elapsed_time);
	cairo_translate (ctx, (double) self->priv->LEFT_OFFSET, (double) 20);
	f = _gpx_point_ref0 ((GpxPoint*) self->track->points->data);
	graph_width = (double) ((win->allocation.width - self->priv->LEFT_OFFSET) - 10);
	graph_height = (double) ((win->allocation.height - 20) - self->priv->BOTTOM_OFFSET);
	if (graph_height < 50) {
		_gpx_point_unref0 (f);
		_cairo_destroy0 (ctx);
		return;
	}
	layout = pango_cairo_create_layout (ctx);
	j = 0.0;
	step_size = graph_height / 8.0;
	g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:466: Draw grid lines");
	cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, 1.0);
	pango_font_description_set_absolute_size (self->priv->fd, (double) (12 * 1024));
	pango_layout_set_font_description (layout, self->priv->fd);
	pango_layout_set_text (layout, "0.0", -1);
	pango_layout_get_pixel_size (layout, &wt, &ht);
	step_size = graph_height / (ceil ((graph_height / (ht + 10)) / 5) * 5);
	{
		gboolean _tmp14_;
		j = (double) 0;
		_tmp14_ = TRUE;
		while (TRUE) {
			double speed;
			char* text;
			gint w = 0;
			gint h = 0;
			if (!_tmp14_) {
				j = j + step_size;
			}
			_tmp14_ = FALSE;
			if (!(j < graph_height)) {
				break;
			}
			speed = min_value + (range * ((graph_height - j) / graph_height));
			text = g_strdup_printf ("%.1f", speed);
			cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, 1.0);
			pango_layout_set_text (layout, text, -1);
			pango_layout_get_pixel_size (layout, &w, &h);
			cairo_move_to (ctx, (double) ((-w) - 5), j - (h / 2.0));
			pango_cairo_layout_path (ctx, layout);
			cairo_fill (ctx);
			g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:487: Set speed tick: %s", text);
			cairo_move_to (ctx, (double) (-4), j);
			cairo_line_to (ctx, (double) 0, j);
			cairo_stroke (ctx);
			cairo_set_source_rgba (ctx, 0.2, 0.2, 0.2, 0.6);
			cairo_set_line_width (ctx, (double) 1);
			cairo_move_to (ctx, 0.0, j);
			cairo_line_to (ctx, graph_width, j);
			cairo_stroke (ctx);
			_g_free0 (text);
		}
	}
	cairo_set_line_width (ctx, 1.5);
	cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, (double) 1);
	cairo_move_to (ctx, 0.0, 0.0);
	cairo_line_to (ctx, 0.0, graph_height);
	cairo_stroke (ctx);
	cairo_line_to (ctx, 0.0, graph_height + ((graph_height / range) * min_value));
	cairo_line_to (ctx, graph_width, graph_height + ((graph_height / range) * min_value));
	cairo_stroke (ctx);
	cairo_set_source_rgba (ctx, 0.1, 0.2, 0.3, (double) 1);
	cairo_set_line_width (ctx, (double) 1);
	iter = g_list_first (self->track->points);
	if (min_value < 0) {
		_tmp15_ = max_value > 0;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		cairo_move_to (ctx, 0.0, graph_height * (max_value / range));
	} else {
		cairo_move_to (ctx, 0.0, graph_height);
	}
	start_speed = (double) 0;
	if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_SPEED) {
		start_speed = ((GpxPoint*) iter->data)->speed;
	} else {
		if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_ELEVATION) {
			start_speed = ((GpxPoint*) iter->data)->elevation - min_value;
		} else {
			if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_DISTANCE) {
				start_speed = ((GpxPoint*) iter->data)->distance;
			} else {
				if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_ACCELERATION_H) {
					start_speed = -min_value;
				} else {
					if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_SPEED_V) {
						start_speed = -min_value;
					}
				}
			}
		}
	}
	cairo_line_to (ctx, 0.0, graph_height * (1 - (start_speed / range)));
	fprintf (stdout, "%f %f %f\n", range, min_value, max_value);
	pref_speed = (double) 2.f;
	pref_speed_threshold = (double) 1.f;
	if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_SPEED) {
		double avg;
		avg = gpx_track_get_track_average (self->track);
		pref_speed_threshold = avg / 5;
	}
	while (TRUE) {
		GList* ii;
		double time_offset;
		gint i;
		double speed;
		gint sf;
		gboolean _tmp18_ = FALSE;
		if (!(iter->next != NULL)) {
			break;
		}
		ii = iter->next;
		time_offset = (double) (gpx_point_get_time ((GpxPoint*) ii->data) - gpx_point_get_time (f));
		i = 0;
		speed = (double) 0;
		sf = self->priv->_smooth_factor;
		{
			gboolean _tmp16_;
			i = 0;
			_tmp16_ = TRUE;
			while (TRUE) {
				gboolean _tmp17_ = FALSE;
				if (!_tmp16_) {
					i++;
				}
				_tmp16_ = FALSE;
				if (i < sf) {
					_tmp17_ = ii->prev != NULL;
				} else {
					_tmp17_ = FALSE;
				}
				if (!_tmp17_) {
					break;
				}
				if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_SPEED) {
					speed = speed + ((GpxPoint*) ii->data)->speed;
				} else {
					if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_ELEVATION) {
						speed = speed + (((GpxPoint*) ii->data)->elevation - min_value);
					} else {
						if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_DISTANCE) {
							speed = speed + ((GpxPoint*) ii->data)->distance;
						} else {
							if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_ACCELERATION_H) {
								speed = speed + (((((GpxPoint*) ii->data)->speed - ((GpxPoint*) ii->prev->data)->speed) / (3.6 * (gpx_point_get_time ((GpxPoint*) ii->data) - gpx_point_get_time ((GpxPoint*) ii->prev->data)))) - min_value);
							} else {
								if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_SPEED_V) {
									speed = speed + (((((GpxPoint*) ii->data)->elevation - ((GpxPoint*) ii->prev->data)->elevation) / (3.6 * (gpx_point_get_time ((GpxPoint*) ii->data) - gpx_point_get_time ((GpxPoint*) ii->prev->data)))) - min_value);
								}
							}
						}
					}
				}
				ii = ii->prev;
			}
		}
		speed = speed / i;
		if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_SPEED) {
			_tmp18_ = pref_speed < pref_speed_threshold;
		} else {
			_tmp18_ = FALSE;
		}
		if (_tmp18_) {
			cairo_line_to (ctx, graph_width * ((double) (time_offset / ((double) elapsed_time))), graph_height * ((double) (1.0 - 0)));
		}
		cairo_line_to (ctx, graph_width * ((double) (time_offset / ((double) elapsed_time))), graph_height * ((double) (1.0 - (speed / range))));
		if (ii->next != NULL) {
			gboolean _tmp19_ = FALSE;
			if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_SPEED) {
				_tmp19_ = ((GpxPoint*) ii->next->data)->speed < pref_speed_threshold;
			} else {
				_tmp19_ = FALSE;
			}
			if (_tmp19_) {
				g_debug ("gpx-graph.vala:589: test123");
				cairo_line_to (ctx, graph_width * ((double) (time_offset / ((double) elapsed_time))), graph_height * ((double) (1.0 - 0)));
			}
		}
		iter = iter->next;
		pref_speed = speed;
	}
	if (min_value < 0) {
		_tmp20_ = max_value > 0;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		cairo_line_to (ctx, graph_width, graph_height * (max_value / range));
	} else {
		cairo_line_to (ctx, graph_width, graph_height * 1);
	}
	cairo_close_path (ctx);
	cairo_stroke_preserve (ctx);
	cairo_set_source_rgba (ctx, 0.1, 0.2, 0.8, 0.5);
	cairo_fill (ctx);
	if (gpx_graph_get_show_points (self)) {
		g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:611: Draw data points");
		cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, 1.0);
		iter = g_list_first (self->track->points);
		while (TRUE) {
			double time_offset;
			double speed;
			GList* ii;
			gint i;
			gint sf;
			if (!(iter->next != NULL)) {
				break;
			}
			time_offset = (double) (gpx_point_get_time ((GpxPoint*) iter->next->data) - gpx_point_get_time (f));
			speed = (double) 0;
			ii = iter->next;
			i = 0;
			sf = self->priv->_smooth_factor;
			{
				gboolean _tmp21_;
				i = 0;
				_tmp21_ = TRUE;
				while (TRUE) {
					gboolean _tmp22_ = FALSE;
					if (!_tmp21_) {
						i++;
					}
					_tmp21_ = FALSE;
					if (i < sf) {
						_tmp22_ = ii->prev != NULL;
					} else {
						_tmp22_ = FALSE;
					}
					if (!_tmp22_) {
						break;
					}
					if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_SPEED) {
						speed = speed + (gpx_track_calculate_point_to_point_speed (self->track, (GpxPoint*) ii->prev->data, (GpxPoint*) ii->data) - min_value);
					} else {
						if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_ELEVATION) {
							speed = speed + (((GpxPoint*) ii->data)->elevation - min_value);
						} else {
							if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_DISTANCE) {
								speed = speed + ((GpxPoint*) ii->data)->distance;
							} else {
								if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_ACCELERATION_H) {
									speed = speed + (((((GpxPoint*) ii->data)->speed - ((GpxPoint*) ii->prev->data)->speed) / (3.6 * (gpx_point_get_time ((GpxPoint*) ii->data) - gpx_point_get_time ((GpxPoint*) ii->prev->data)))) - min_value);
								} else {
									if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_SPEED_V) {
										speed = speed + (((((GpxPoint*) ii->data)->elevation - ((GpxPoint*) ii->prev->data)->elevation) / (3.6 * (gpx_point_get_time ((GpxPoint*) ii->data) - gpx_point_get_time ((GpxPoint*) ii->prev->data)))) - min_value);
									}
								}
							}
						}
					}
					ii = ii->prev;
				}
			}
			speed = speed / i;
			cairo_rectangle (ctx, (graph_width * ((double) (time_offset / ((double) elapsed_time)))) - 1, (graph_height * ((double) (1.0 - (speed / range)))) - 1, (double) 2, (double) 2);
			cairo_stroke (ctx);
			iter = iter->next;
		}
	}
	g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:646: Draw graph");
	iter = g_list_first (self->track->points);
	cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, 1.0);
	pango_font_description_set_absolute_size (self->priv->fd, (double) (12 * 1024));
	pango_layout_set_font_description (layout, self->priv->fd);
	interval = ((guint) elapsed_time) / ((guint) (graph_width / (5 * 12.0)));
	current = 0;
	{
		gboolean _tmp23_;
		i = (guint) 0;
		_tmp23_ = TRUE;
		while (TRUE) {
			gboolean _tmp24_ = FALSE;
			if (!_tmp23_) {
				i = i + interval;
			}
			_tmp23_ = FALSE;
			if (i < elapsed_time) {
				_tmp24_ = interval > 0;
			} else {
				_tmp24_ = FALSE;
			}
			if (!_tmp24_) {
				break;
			}
			if ((graph_width * (1 - (i / elapsed_time))) > (2.5 * 12)) {
				gint w = 0;
				gint h = 0;
				char* text;
				text = g_strdup_printf ("%02i:%02i", ((gint) i) / 3600, (((gint) i) % 3600) / 60);
				pango_layout_set_text (layout, text, -1);
				pango_layout_get_pixel_size (layout, &w, &h);
				cairo_move_to (ctx, (graph_width * ((double) (i / elapsed_time))) - (w / 2.0), graph_height + 10);
				pango_cairo_layout_path (ctx, layout);
				cairo_fill (ctx);
				g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:667: Set time tick: %s", text);
				cairo_move_to (ctx, graph_width * ((double) (i / elapsed_time)), graph_height);
				cairo_line_to (ctx, graph_width * ((double) (i / elapsed_time)), graph_height + 5);
				cairo_stroke (ctx);
				_g_free0 (text);
			}
			current++;
		}
	}
	if (self->priv->_mode == GPX_GRAPH_GRAPH_MODE_SPEED) {
		double avg;
		time_t moving_time;
		avg = gpx_track_get_track_average (self->track);
		cairo_set_source_rgba (ctx, 0.0, 0.7, 0.0, 0.7);
		cairo_move_to (ctx, 0.0, graph_height * (1 - (avg / max_value)));
		cairo_line_to (ctx, graph_width, graph_height * (1 - (avg / max_value)));
		cairo_stroke (ctx);
		g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:685: Draw average speed line @ %.02f km/h", avg);
		avg = gpx_track_calculate_moving_average (self->track, (GpxPoint*) g_list_first (self->track->points)->data, (GpxPoint*) g_list_last (self->track->points)->data, &moving_time);
		cairo_set_source_rgba (ctx, 0.7, 0.0, 0.0, 0.7);
		cairo_move_to (ctx, 0.0, graph_height * (1 - (avg / max_value)));
		cairo_line_to (ctx, graph_width, graph_height * (1 - (avg / max_value)));
		cairo_stroke (ctx);
		g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:695: Draw moving average speed line @ %.02f km/h", avg);
	}
	cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, 1.0);
	pango_font_description_set_absolute_size (self->priv->fd, (double) (12 * 1024));
	pango_layout_set_font_description (layout, self->priv->fd);
	mtext = g_strdup (_ (gpx_graph_GraphModeName[self->priv->_mode]));
	if (self->priv->_smooth_factor != 1) {
		char* markup;
		markup = g_strdup_printf (_ ("%s <i>(smooth window: %i)</i>"), mtext, self->priv->_smooth_factor);
		pango_layout_set_markup (layout, markup, -1);
		g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:708: Set graph title: %s", markup);
		_g_free0 (markup);
	} else {
		pango_layout_set_text (layout, mtext, -1);
		g_log (LOG_DOMAIN, G_LOG_LEVEL_DEBUG, "gpx-graph.vala:714: Set graph title: %s", mtext);
	}
	pango_layout_get_pixel_size (layout, &w, &h);
	cairo_move_to (ctx, (graph_width / 2) - (w / 2), (double) (-20));
	pango_cairo_layout_path (ctx, layout);
	cairo_fill (ctx);
	_g_free0 (mtext);
	_g_object_unref0 (layout);
	_gpx_point_unref0 (f);
	_cairo_destroy0 (ctx);
}


gint gpx_graph_get_smooth_factor (GpxGraph* self) {
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_smooth_factor;
	return result;
}


void gpx_graph_set_smooth_factor (GpxGraph* self, gint value) {
	cairo_surface_t* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_smooth_factor = value;
	self->priv->surf = (_tmp0_ = NULL, _cairo_surface_destroy0 (self->priv->surf), _tmp0_);
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_object_notify ((GObject *) self, "smooth-factor");
}


gboolean gpx_graph_get_show_points (GpxGraph* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_points;
	return result;
}


void gpx_graph_set_show_points (GpxGraph* self, gboolean value) {
	cairo_surface_t* _tmp0_;
	g_return_if_fail (self != NULL);
	self->priv->_show_points = value;
	self->priv->surf = (_tmp0_ = NULL, _cairo_surface_destroy0 (self->priv->surf), _tmp0_);
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_object_notify ((GObject *) self, "show-points");
}


GpxGraphGraphMode gpx_graph_get_mode (GpxGraph* self) {
	GpxGraphGraphMode result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_mode;
	return result;
}


void gpx_graph_set_mode (GpxGraph* self, GpxGraphGraphMode value) {
	g_return_if_fail (self != NULL);
	if (value != self->priv->_mode) {
		cairo_surface_t* _tmp0_;
		self->priv->_mode = value;
		self->priv->surf = (_tmp0_ = NULL, _cairo_surface_destroy0 (self->priv->surf), _tmp0_);
		gtk_widget_queue_draw ((GtkWidget*) self);
	}
	g_object_notify ((GObject *) self, "mode");
}


static void gpx_graph_class_init (GpxGraphClass * klass) {
	char** _tmp0_ = NULL;
	gpx_graph_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GpxGraphPrivate));
	GTK_WIDGET_CLASS (klass)->expose_event = gpx_graph_real_expose_event;
	G_OBJECT_CLASS (klass)->get_property = gpx_graph_get_property;
	G_OBJECT_CLASS (klass)->set_property = gpx_graph_set_property;
	G_OBJECT_CLASS (klass)->finalize = gpx_graph_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPX_GRAPH_SMOOTH_FACTOR, g_param_spec_int ("smooth-factor", "smooth-factor", "smooth-factor", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPX_GRAPH_SHOW_POINTS, g_param_spec_boolean ("show-points", "show-points", "show-points", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GPX_GRAPH_MODE, g_param_spec_enum ("mode", "mode", "mode", GPX_GRAPH_TYPE_GRAPH_MODE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("point_clicked", GPX_TYPE_GRAPH, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__GPX_POINT, G_TYPE_NONE, 1, GPX_TYPE_POINT);
	g_signal_new ("selection_changed", GPX_TYPE_GRAPH, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_GPX_POINT_GPX_POINT, G_TYPE_NONE, 3, GPX_TYPE_TRACK, GPX_TYPE_POINT, GPX_TYPE_POINT);
	gpx_graph_GraphModeName = (_tmp0_ = g_new0 (char*, 5 + 1), _tmp0_[0] = g_strdup (N_ ("Speed (km/h) vs Time (HH:MM)")), _tmp0_[1] = g_strdup (N_ ("Elevation (m) vs Time (HH:MM)")), _tmp0_[2] = g_strdup (N_ ("Distance (km) vs Time (HH:MM)")), _tmp0_[3] = g_strdup (N_ ("Horizontal acceleration (m/s) vs Time (HH:MM)")), _tmp0_[4] = g_strdup (N_ ("Vertical speed (m/s) vs Time (HH:MM)")), _tmp0_);
	gpx_graph_GraphModeName_length1 = 5;
}


static void gpx_graph_instance_init (GpxGraph * self) {
	self->priv = GPX_GRAPH_GET_PRIVATE (self);
	self->track = NULL;
	self->priv->_mode = GPX_GRAPH_GRAPH_MODE_ELEVATION;
	self->priv->_smooth_factor = 1;
	self->priv->_show_points = TRUE;
	self->priv->fd = NULL;
	self->priv->surf = NULL;
	self->priv->LEFT_OFFSET = 60;
	self->priv->BOTTOM_OFFSET = 30;
	self->priv->highlight = (time_t) 0;
	self->priv->draw_current = NULL;
	self->priv->start = NULL;
	self->priv->stop = NULL;
}


static void gpx_graph_finalize (GObject* obj) {
	GpxGraph * self;
	self = GPX_GRAPH (obj);
	{
		g_debug ("gpx-graph.vala:724: Destroying graph");
	}
	_g_object_unref0 (self->track);
	_pango_font_description_free0 (self->priv->fd);
	_cairo_surface_destroy0 (self->priv->surf);
	_gpx_point_unref0 (self->priv->start);
	_gpx_point_unref0 (self->priv->stop);
	G_OBJECT_CLASS (gpx_graph_parent_class)->finalize (obj);
}


GType gpx_graph_get_type (void) {
	static volatile gsize gpx_graph_type_id__volatile = 0;
	if (g_once_init_enter (&gpx_graph_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GpxGraphClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpx_graph_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GpxGraph), 0, (GInstanceInitFunc) gpx_graph_instance_init, NULL };
		GType gpx_graph_type_id;
		gpx_graph_type_id = g_type_register_static (GTK_TYPE_EVENT_BOX, "GpxGraph", &g_define_type_info, 0);
		g_once_init_leave (&gpx_graph_type_id__volatile, gpx_graph_type_id);
	}
	return gpx_graph_type_id__volatile;
}


static void gpx_graph_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GpxGraph * self;
	self = GPX_GRAPH (object);
	switch (property_id) {
		case GPX_GRAPH_SMOOTH_FACTOR:
		g_value_set_int (value, gpx_graph_get_smooth_factor (self));
		break;
		case GPX_GRAPH_SHOW_POINTS:
		g_value_set_boolean (value, gpx_graph_get_show_points (self));
		break;
		case GPX_GRAPH_MODE:
		g_value_set_enum (value, gpx_graph_get_mode (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void gpx_graph_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GpxGraph * self;
	self = GPX_GRAPH (object);
	switch (property_id) {
		case GPX_GRAPH_SMOOTH_FACTOR:
		gpx_graph_set_smooth_factor (self, g_value_get_int (value));
		break;
		case GPX_GRAPH_SHOW_POINTS:
		gpx_graph_set_show_points (self, g_value_get_boolean (value));
		break;
		case GPX_GRAPH_MODE:
		gpx_graph_set_mode (self, g_value_get_enum (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



static void g_cclosure_user_marshal_VOID__GPX_POINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__GPX_POINT) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__GPX_POINT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__GPX_POINT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, gpx_value_get_point (param_values + 1), data2);
}


static void g_cclosure_user_marshal_VOID__OBJECT_GPX_POINT_GPX_POINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_GPX_POINT_GPX_POINT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_GPX_POINT_GPX_POINT callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__OBJECT_GPX_POINT_GPX_POINT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_object (param_values + 1), gpx_value_get_point (param_values + 2), gpx_value_get_point (param_values + 3), data2);
}



